<template>
  <div class="row">
    <AddProducts class="col-sm-5 col-12" :accion="accion" :producto="producto" :id="id"></AddProducts>
    <div class="col-sm-7 col-12">
      <card :title="table1.title" :subTitle="table1.subTitle">
        <!-- <router-link to="/products/add">
          <button class="btn btn-primary align-text-rigth">Agregar</button>
        </router-link>-->
        <div slot="raw-content" class="table-responsive">
          <paper-table
            @eliminar="this.eliminarProducto"
            @editar="this.editarProducto"
            :data="table1.data"
            :columns="table1.columns"
          >
            <template slot-scope="{row,index}">
              <td>
                <b>{{row.nombre}}</b>
              </td>
              <td>$ {{row.precio}}</td>
              <td>{{row.existencia}}</td>
              <td> <img :src="row.img_url" width="70px"></td>
              <td>
                <p-button class="btn btn-sm" type="info" icon @click.native="editarProducto(index)">
                  <i class="ti ti-pencil-alt"></i>
                </p-button>
                <p-button
                  class="btn btn-sm"
                  style="margin-left: 5px;"
                  type="danger"
                  icon
                  @click.native="eliminarProducto(index,row.img_ref)"
                >
                  <i class="ti ti-close"></i>
                </p-button>
              </td>
            </template>
          </paper-table>
        </div>
      </card>
    </div>
  </div>
</template>
<script>
import { PaperTable } from "@/components";
import AddProducts from "./AddProducts";
import { db, storage } from "@/conexion";
import swal from "sweetalert";

const tableColumns = ["Nombre", "Precio", "Existencia", "Imagen"];
const productos = [];

export default {
  components: {
    PaperTable,
    AddProducts
  },
  created() {
    db.ref("/productos").on("value", res => {
      this.listarProductos(res.val());
    });
  },
  data() {
    return {
      table1: {
        title: "Lista de productos",
        subTitle: "Lista de productos de la tienda",
        columns: [...tableColumns],
        data: [...productos]
      },
      producto: {
        nombre: null,
        precio: null,
        existencia: 0,
        img_url: null,
        img_ref: null
      },
      accion: "Add",
      id: null
    };
  },
  methods: {
    listarProductos(productos) {
      this.table1.data = productos;
    },
    editarProducto(key) {
      db.ref("/productos/" + key).on("value", res => {
        this.producto = res.val();
        this.id = key;
        this.accion = "Edit";
      });
    },
    eliminarProducto(key, img_ref) {
      swal({
        title: "Seguro?",
        text: "Desea eliminar el producto",
        icon: "warning",
        buttons: true,
        dangerMode: true
      }).then(willDelete => {
        if (willDelete) {
          db.ref("/productos/" + key)
            .remove()
            .then(() => {
              storage.ref(img_ref).delete().then(function() {
                swal("Producto eliminado", "", "success");
              }).catch(function(error) {
                // Uh-oh, an error occurred!
              });;
              
              
            });
        }
      });
    }
  }
};
</script>
<style>
</style>
